/*!
 * MIT License
 *
 * Copyright (c) 2020 Michael Marcenich
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
var WorkboxFirebaseAuth=function(t){"use strict";const e=["analytics","firestore","functions","messaging","storage","performance","database","config"],s=()=>new Promise((t,e)=>{const s=firebase.auth().onAuthStateChanged(r=>{s(),r?r.getIdToken(!0).then(e=>{t(e)},()=>{t(null)}).catch(t=>{e(t)}):t(null)})}),r=(t,e)=>{const s=new URL(t.url),r=!e.sameOrigin||self.location.origin===s.origin,i=((t,e)=>{const s=e&&e.split(",").map(t=>t.split(";")[0].trim());return!t.length||t.includes("*")||!s||s.some(e=>t.some(t=>new RegExp(`^${t.replace("*","[^/]*")}$`).test(e)))})(e.types,t.headers.get("accept")),a=!e.https||"https:"===self.location.protocol||"localhost"===self.location.hostname,n=!!e.ignorePaths.length&&e.ignorePaths.some(t=>"string"==typeof t?s.pathname.startsWith(t):t.test(s.pathname));return r&&i&&a&&!n},i=(t,e)=>{const s=new Headers;t.headers.forEach((t,e)=>{s.append(e,t)}),s.append("Authorization","Bearer "+e);const{url:r,...i}=t.clone();return new Request(r,{...i,mode:"same-origin",redirect:"manual",headers:s})};return t.Plugin=class{constructor(t={}){this.requestWillFetch=async({request:t})=>{if(this.awaitResponse||!r(t,this.constraints))return t;try{const e=await s();return e?i(t,e):t}catch(e){return console.error(e),t}},this.fetchDidSucceed=async({request:t,response:e})=>{if(!this.awaitResponse||401!==e.status||!r(t,this.constraints))return e;try{const r=await s();if(!r)return e;const a=i(t,r);return await fetch(a)}catch(t){return console.error(t),e}},this.awaitResponse=t.awaitResponse||!1;const{types:e,https:a,sameOrigin:n,ignorePaths:o}=t.constraints||{};this.constraints={types:"string"==typeof e?[e]:e||["*"],https:!!a,sameOrigin:"boolean"!=typeof n||n,ignorePaths:o||[]}}},t.initializeFirebase=({version:t="7.19.1",services:s=[],config:r}={})=>{const i=s.filter(t=>e.includes(t));r?(importScripts(`https://www.gstatic.com/firebasejs/${t}/firebase-app.js`),importScripts(`https://www.gstatic.com/firebasejs/${t}/firebase-auth.js`),i.forEach(e=>{importScripts(`https://www.gstatic.com/firebasejs/${t}/firebase-${e}.js`)}),firebase.initializeApp(r)):(importScripts(`/__/firebase/${t}/firebase-app.js`),importScripts(`/__/firebase/${t}/firebase-auth.js`),i.forEach(e=>{importScripts(`/__/firebase/${t}/firebase-${e}.js`)}),importScripts("/__/firebase/init.js"))},t}({});
